﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace valasztas
{
    class Program
    {
        static void Main(string[] args)
        {
            int[] areaCode = new int[100];
            int[] vote = new int[100];
            string[] fName = new string[100];
            string[] sName = new string[100];
            string[] part = new string[100];

            Console.WriteLine("1. feladat");
            StreamReader sr = new StreamReader("szavazatok.txt");
            int n = 0;
            while (!sr.EndOfStream)
            {
                string[] sor = sr.ReadLine().Split(' ');
                areaCode[n] = int.Parse(sor[0]);
                vote[n] = int.Parse(sor[1]);
                fName[n] = sor[2];
                sName[n] = sor[3];
                if (sor[4] == "-")
                {
                    part[n] = "Független";
                }
                else
                {
                    part[n] = sor[4];
                }
                n++;
            }
            sr.Close();

            Console.WriteLine();
            Console.WriteLine("2. feladat");
            Console.WriteLine("A helyhatósági választáson " + n + " képviselőjelölt indult.");

            Console.WriteLine();
            Console.WriteLine("3. feladat");
            Console.Write("Adja meg a képviselő vezetéknevét: ");
            string vezetéknév = Console.ReadLine();
            Console.Write("Adja meg a képviselő keresztnevét: ");
            string keresztnév = Console.ReadLine();
            bool van = false;
            for (int i = 0; i < n; i++)
            {
                if (vezetéknév == fName[i] && keresztnév == sName[i])
                {
                    Console.WriteLine("A képviselőjelölt " + vote[i] + "db szavazatot kapott.");
                    van = true;
                }
            }
            if (!van)
            {
                Console.WriteLine("Ilyen nevű képviselőjelölt nem szerepel a nyilvántartásban!");
            }

            Console.WriteLine();
            Console.WriteLine("4. feladat");
            int sum = 0;
            for (int i = 0; i < n; i++)
            {
                sum = sum + vote[i];
            }

            double rate = Math.Round(sum * 100.0 / 12345, 2);
            Console.WriteLine("A választáson " + sum + " állampolgár, a jogosultak " + rate + "%-a vett részt.");

            Console.WriteLine();
            Console.WriteLine("5. feladat");
            int gyep = 0;
            int hep = 0;
            int tisz = 0;
            int zep = 0;
            int fgtlen = 0;

            for (int i = 0; i < n; i++)
            {
                if (part[i] == "GYEP")
                {
                    gyep = gyep + vote[i];
                }
                else if (part[i] == "HEP")
                {
                    hep = hep + vote[i];
                }
                else if (part[i] == "ZEP")
                {
                    zep = zep + vote[i];
                }
                else if (part[i] == "TISZ")
                {
                    tisz = tisz + vote[i];
                }
                else
                {
                    fgtlen = fgtlen + vote[i];
                }
            }
            Console.WriteLine("Gyümülcsevők pártja = " + Math.Round(gyep * 100.0 / sum, 2) + "%");
            Console.WriteLine("Húsevők pártja = " + Math.Round(hep * 100.0 / sum, 2) + "%");
            Console.WriteLine("Tejívók pártja = " + Math.Round(tisz * 100.0 / sum, 2) + "%");
            Console.WriteLine("Zöldségevők pártja = " + Math.Round(zep * 100.0 / sum, 2) + "%");
            Console.WriteLine("Független jelöltek = " + Math.Round(fgtlen * 100.0 / sum, 2) + "%");

            Console.WriteLine();
            Console.WriteLine("6. feladat");
            int max = -1;
            for (int i = 0; i < n; i++)
            {
                if (vote[i] > max)
                {
                    max = vote[i];
                }
            }
            for (int i = 0; i < n; i++)
            {
                if (vote[i] == max)
                {
                    Console.WriteLine(fName[i] + " " + sName[i] + " " + part[i]);
                }
            }

            Console.WriteLine();
            Console.WriteLine("7. feladat");
            int[] district = new int[9];
            for (int d = 0; d < 9; d++)
            {
                district[d] = -1;
            }
            for (int i = 0; i < n; i++)
            {
                for (int d = 1; d < 9; d++)
                {
                    if (areaCode[i] == d && (district[d] == -1 || vote[i] > vote[district[d]]))
                    {
                        district[d] = i;
                    }
                }
            }

            StreamWriter sw = new StreamWriter("kepviselok.txt");
            for (int d = 1; d < 9; d++)
            {
                sw.WriteLine(d + ": " + fName[district[d]] + " " + sName[district[d]] + " " + part[district[d]]);
            }           
            sw.Close();

            Console.WriteLine("kész");
            Console.ReadLine();
        }
    }
}
